// Given a word list and one word specified in setup(),
// Find all anagrams of all subsets of the specified word
// that are in the word list.  Useful for cheating at 
// Scrabble (though it doesn't handle blanks).

IntDict dict;

boolean isWord( String wd )
{
  return dict.hasKey( wd );
}

// Return a new array in which the element at position
// idx has been removed.
char[] removeChar( char[] arr, int idx )
{
  char[] ret = new char[0];
  for( int l = 0; l < arr.length; ++l ) {
    if( l != idx ) {
      ret = append( ret, arr[l] );
    }
  }
  return ret;
}

void checkWord( String wrd )
{
  if( isWord( wrd ) ) {
    println( wrd );
  }
}

void tryAllWords( String prefix, char[] letters )
{
  if( prefix.length() > 1 ) {
    checkWord( prefix );
  }
  
  // Uncomment this code to avoid trying the same letter
  // more than once in this position in the word.  Avoids
  // producing duplicate output words.
  /*
  boolean[] checked = new boolean[26];
  for( int idx = 0; idx < 26; ++idx ) {
    checked[idx] = false;
  }*/
  
  for( int idx = 0; idx < letters.length; ++idx ) {
    char let = letters[idx];
    /*
    // Uncomment this too if you want to avoid duplicates.
    if( checked[let-'a'] ) {
      continue;
    }
    checked[let-'a'] = true;
    */
    tryAllWords(
      prefix + let,
      removeChar( letters, idx ) );
  }
}

void setup()
{
  String[] wds = loadStrings( "words.txt" );
  dict = new IntDict();
  for( int idx = 0; idx < wds.length; ++idx ) {
    dict.set( wds[idx], 1 );
  }
 
  String letters = "carrost";
  tryAllWords( "", letters.toCharArray() );
}
